/* $Filename:    WormWars/Source/engine.h $
 * $VER:         WormWars 4.2 $
 * $Description: Header file for game engine $
 *
 *  Copyright 1999 James R. Jacobs.
 *
 * Constants. Used by engine,c (Amiga) and engine.cpp (IBM-PC)
 */

#define NOSE				 2		// set >PROTECTORS for no nose
#define NOSEDISTANCE		 4
#define RESTFULNESS			 5		// must be non-0
#define QUEUELIMIT			 15
#define SECONDSPERLEVEL		120		// 2:00; don't set >9:59 (ie. >599)

// population limits

#define DRIPS				  3
#define KILLERS				  7		// <=ORBS+1!
#define ORBS				  6
#define PROTECTORS			  2		// <=4!
#define TIMEBOMBS			  3

// vampirism

#define KILLERBLOOD			1
#define ORBBLOOD			1

// jump distances

#define FASTDISTANCE		5
#define NORMALDISTANCE		4
#define SLOWDISTANCE		3

// skill points

#define EMPTYPOINT		   1
#define TAILBONUS		   1
#define TURNTOSILVER	   5
#define TURNTOGOLD		  10
#define SILVERPOINT		  10
#define TIMEBONUS		  10
#define TELPOINT		  40
#define GOLDPOINT		  20
#define HITSHOT			  50
#define KILLKILLER		  50
#define KILLWORM		 100
#define BOMBOVEREDGE	 100
#define SKULLPOINT		 100
#define YOURLETTER		 100
#define DRIPBONUS		 100
#define LEVELBONUS		 100
#define MYLETTER		 200
#define SURVIVOR		 500

// pain ratings

#define DRIPPAIN		5
#define HEADPAIN		5
#define MISSILEPAIN		5
#define ORBPAIN			5
#define PROTECTORPAIN	5
#define TELEPORTPAIN	5
#define WORMFIREPAIN	5

#define FRAGMENTPAIN	3
#define OTHERTAILPAIN	3
#define BOMBPAIN		3

#define SLIMEPAIN		2
#define KILLERPAIN		2
#define SLAYERPAIN		2
#define METALPAIN		2

#define WOODPAIN		1
#define TAILPAIN		1
#define STONEPAIN		1

// objects

#define BOMBADD			 5	// in squares radius
#define BOMBRAND		25
#define CLOCKADD		10	// in seconds
#define CLOCKRAND		20
#define ICEADD			 5	// in VERYSLOWs
#define ICERAND			 5
#define MODEADD			30	// in VERYSLOWs
#define MODERAND		40
#define TREASUREADD		 5	// in seconds
#define TREASURERAND	 5

// Must have blank line at EOF.
